#ifndef INTUITION_H
#include <intuition/intuition.h>
#endif
#include "LabelDef.h"

extern struct Image ContinueImage, GirlImage, NoImage, YesImage;

BYTE TextBuffer[61], UTextBuffer[61];
BYTE WholeText[257], UWholeText[257];
BYTE GapBuffer[11], GapUBuffer[11];
BYTE PrintWidthBuffer[11], PrintWidthUBuffer[11];
BYTE PrintHeightBuffer[11], PrintHeightUBuffer[11];

struct StringInfo TextInfo =
{
 TextBuffer,
 UTextBuffer,
 0,61,
 0,0,0,
 0,0,0,
 NULL, NULL, NULL
};

struct StringInfo WholeTextInfo =
{
 WholeText,
 UWholeText,
 0,257,
 0,0,0,
 0,0,0,
 NULL, NULL, NULL
};


struct Gadget LoadLabelGadg =
{
 NULL,
 514, 15,
 124, 11,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 1,
 NULL
};

struct Gadget SaveLabelGadg =
{
 &LoadLabelGadg,
 514, 27,
 124, 11,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 2,
 NULL
};

struct Gadget LoadPicGadg =
{
 &SaveLabelGadg,
 514, 39,
 124, 11,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 3,
 NULL
};

struct Gadget LoadTextGadg =
{
 &LoadPicGadg,
 514, 51,
 124, 11,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 4,
 NULL
};

struct Gadget EnterTextGadg =
{
 &LoadTextGadg,
 514, 65,
 124, 11,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 5,
 NULL
};

struct Gadget EditTextGadg =
{
 &EnterTextGadg,
 514, 77,
 124, 11,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 6,
 NULL
};

struct Gadget MoveTextGadg =
{
 &EditTextGadg,
 514, 89,
 124, 11,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 7,
 NULL
};

struct Gadget MovePicGadg =
{
 &MoveTextGadg,
 514, 101,
 124, 11,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 8,
 NULL
};

struct Gadget RemoveTextGadg =
{
 &MovePicGadg,
 514, 113,
 124, 11,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 9,
 NULL
};

struct Gadget RemovePicGadg =
{
 &RemoveTextGadg,
 514, 125,
 124, 11,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 10,
 NULL
};

struct Gadget RemoveAllGadg =
{
 &RemovePicGadg,
 514, 137,
 124, 11,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 11,
 NULL
};

struct Gadget PrintGadg =
{
 &RemoveAllGadg,
 514, 151,
 124, 11,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 12,
 NULL
};

struct Gadget SetUpGadg =
{
 &PrintGadg,
 514, 163,
 124, 11,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 13,
 NULL
};

struct Gadget InformationGadg =
{
 &SetUpGadg,
 514, 175,
 124, 11,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 14,
 NULL
};

struct Gadget QuitGadg =
{
 &InformationGadg,
 514, 187,
 124, 11,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 15,
 NULL
};

struct Gadget LabelFieldGadg =
{
 &QuitGadg,
 LABEL_LEFT, LABEL_TOP,
 LABEL_WIDTH, LABEL_HEIGHT,
 GADGHNONE,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 16,
 NULL
};

/* END OF CONTROL GADGETS */

struct Gadget FontUpGadg =
{
 NULL,
 46, 4,
 22, 11,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 1,
 NULL
};

struct Gadget FontDownGadg =
{
 &FontUpGadg,
 70, 4,
 22, 11,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 2,
 NULL
};

struct Gadget StyleUnderGadg =
{
 &FontDownGadg,
 268, 4,
 22, 11,
 GADGHNONE,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 3,
 NULL
};

struct Gadget StyleBoldGadg =
{
 &StyleUnderGadg,
 292, 4,
 22, 11,
 GADGHNONE,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 4,
 NULL
};

struct Gadget StyleItalGadg =
{
 &StyleBoldGadg,
 326, 4,
 22,11,
 GADGHNONE,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 5,
 NULL
};

struct Gadget PlaceFixedGadg =
{
 &StyleItalGadg,
 46, 16,
 22, 11,
 GADGHNONE,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 6,
 NULL
};

struct Gadget PlaceFreeGadg =
{
 &PlaceFixedGadg,
 70, 16,
 22, 11,
 GADGHNONE,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 7,
 NULL
};

struct Gadget AlignLeftGadg =
{
 &PlaceFreeGadg,
 140, 16,
 22, 11,
 GADGHNONE,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 8,
 NULL
};

struct Gadget AlignRightGadg =
{
 &AlignLeftGadg,
 164, 16,
 22, 11,
 GADGHNONE,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 9,
 NULL
};

struct Gadget AlignCenterGadg =
{
 &AlignRightGadg,
 188, 16,
 22, 11,
 GADGHNONE,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 10,
 NULL
};

struct Gadget BorderDownGadg =
{
 &AlignCenterGadg,
 268, 16,
 22, 11,
 GADGHNONE,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 11,
 NULL
};

struct Gadget BorderUpGadg =
{
 &BorderDownGadg,
 292, 16,
 22, 11,
 GADGHNONE,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 12,
 NULL
};

struct Gadget BorderSidesGadg =
{
 &BorderUpGadg,
 326, 16,
 22, 11,
 GADGHNONE,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 13,
 NULL
};

struct Gadget BgColorsGadg =
{
 &BorderSidesGadg,
 48, 29,
 288, 9,
 GADGHNONE,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 14,
 NULL
};

struct Gadget FgColorsGadg =
{
 &BgColorsGadg,
 48, 41,
 288, 9,
 GADGHNONE,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 15,
 NULL
};

struct Gadget TextGadg =
{
 &FgColorsGadg,
 48, 53,
 288, 9,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY,
 STRGADGET,
 NULL, NULL, NULL, NULL,
 (APTR) &TextInfo,
 16,
 NULL
};

struct Gadget DoSoGadg =
{
 &TextGadg,
 10, 65,
 50, 11,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 17,
 NULL
};

struct Gadget CancelGadg =
{
 &DoSoGadg,
 286, 65,
 50, 11,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 18,
 NULL
};

struct NewWindow EditWinData =
{
 147,60,
 346,80,
 0,0,
 GADGETUP,
 BORDERLESS | ACTIVATE | RMBTRAP| NOCAREREFRESH | BACKDROP,
 &CancelGadg,
 NULL,NULL,
 NULL,NULL,NULL,
 NULL,NULL,NULL,
 CUSTOMSCREEN,
};

struct NewWindow LabelWinData =
{
 0,0,
 640,200,
 0,1,
 GADGETUP,
 BORDERLESS | ACTIVATE | RMBTRAP | BACKDROP,
 &LabelFieldGadg,
 NULL,NULL,
 NULL,NULL,NULL,
 NULL,NULL,NULL,
 CUSTOMSCREEN,
};

struct NewWindow WorkWinData =
{
 0,0,
 320,200,
 0,0,
 NULL,
 BORDERLESS | ACTIVATE | RMBTRAP | BACKDROP,
 NULL,
 NULL,NULL,
 NULL,NULL,NULL,
 NULL,NULL,NULL,
 CUSTOMSCREEN,
};


struct NewScreen LabelScreenData =
{
 0,0,
 640,200,4,
 0,1,
 HIRES,
 CUSTOMSCREEN,
 NULL,
 NULL,
 NULL,
 NULL
};

struct NewScreen WorkScreenData =
{
 0,0,
 320,200,4,
 0,1,
 HIRES,
 CUSTOMSCREEN | SCREENBEHIND,
 NULL,
 NULL,
 NULL,
 NULL
};

struct NewScreen PicScreenData =
{
 0,0,
 320,200,4,
 0,1,
 HIRES,
 CUSTOMSCREEN | SCREENBEHIND,
 NULL,
 NULL,
 NULL,
 NULL
};

struct Gadget GirlGadg = {
        NULL,           /* NextGadget */
        -88, -88,      /* LeftEdge, TopEdge */
        80, 72,                /* Width, Height */
        GADGIMAGE|GADGHCOMP| GRELRIGHT | GRELBOTTOM,    /* Flags */
        RELVERIFY,      /* Activation */
        BOOLGADGET,     /* GadgetType */
        (APTR)&GirlImage,       /* GadgetRender */
        NULL,           /* SelectRender */
        NULL,           /* GadgetText */
        0L,             /* MutualExclude */
        NULL,           /* SpecialInfo */
        1,              /* GadgetID */
        NULL,           /* UserData */
};

struct Gadget ContinueGadg = {
        NULL,           /* NextGadget */
        -76, -15,       /* LeftEdge, TopEdge */
        71, 13,         /* Width, Height */
        GADGIMAGE|GADGHCOMP| GRELRIGHT | GRELBOTTOM,    /* Flags */
        RELVERIFY,      /* Activation */
        BOOLGADGET,     /* GadgetType */
        (APTR)&ContinueImage,   /* GadgetRender */
        NULL,           /* SelectRender */
        NULL,           /* GadgetText */
        0L,             /* MutualExclude */
        NULL,           /* SpecialInfo */
        2,              /* GadgetID */
        NULL,           /* UserData */
};

struct NewWindow MessWinData =
{
 0,0,
 640,200,
 1,1,
 GADGETUP,
 BORDERLESS | ACTIVATE | RMBTRAP | BACKDROP,
 &ContinueGadg,
 NULL, NULL,
 NULL,NULL,NULL,
 NULL,NULL,NULL,
 CUSTOMSCREEN,
};

struct Gadget WholeTextGadg =
{
 NULL,
 8, 30,
 288, 8,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY,
 STRGADGET,
 NULL, NULL, NULL, NULL,
 (APTR) &WholeTextInfo,
 3,
 NULL
};

struct Gadget YesGadg = {
        NULL,          /* NextGadget */
        6, -15,        /* LeftEdge, TopEdge */
        31, 13,        /* Width, Height */
        GADGIMAGE|GADGHCOMP|GRELBOTTOM,    /* Flags */
        RELVERIFY,      /* Activation */
        BOOLGADGET,     /* GadgetType */
        (APTR)&YesImage,        /* GadgetRender */
        NULL,           /* SelectRender */
        NULL,           /* GadgetText */
        0L,             /* MutualExclude */
        NULL,           /* SpecialInfo */
        1,              /* GadgetID */
        NULL,           /* UserData */
};

struct Gadget NoGadg = {
        &YesGadg,       /* NextGadget */
        -36, -15,       /* LeftEdge, TopEdge */
        31, 13,         /* Width, Height */
        GADGIMAGE|GADGHCOMP|GRELRIGHT|GRELBOTTOM,    /* Flags */
        RELVERIFY,      /* Activation */
        BOOLGADGET,     /* GadgetType */
        (APTR)&NoImage, /* GadgetRender */
        NULL,           /* SelectRender */
        NULL,           /* GadgetText */
        0L,             /* MutualExclude */
        NULL,           /* SpecialInfo */
        2,              /* GadgetID */
        NULL,           /* UserData */
};

struct NewWindow BoolWinData =
{
 0,0,
 640,200,
 1,1,
 GADGETUP,
 BORDERLESS | ACTIVATE | RMBTRAP | BACKDROP,
 &NoGadg,
 NULL, NULL,
 NULL,NULL,NULL,
 NULL,NULL,NULL,
 CUSTOMSCREEN,
};

struct StringInfo PrintWidthInfo =
{
 PrintWidthBuffer,
 PrintWidthUBuffer,
 0,11,
 0,0,0,
 0,0,0,
 NULL, NULL, NULL
};

struct StringInfo PrintHeightInfo =
{
 PrintHeightBuffer,
 PrintHeightUBuffer,
 0,11,
 0,0,0,
 0,0,0,
 NULL, NULL, NULL
};

struct StringInfo LabelGapInfo =
{
 GapBuffer,
 GapUBuffer,
 0,11,
 0,0,0,
 0,0,0,
 NULL, NULL, NULL
};

struct Gadget PrintWidthGadg =
{
 NULL,
 176, 5,
 40, 9,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY | LONGINT,
 STRGADGET,
 NULL, NULL, NULL, NULL,
 (APTR) &PrintWidthInfo,
 1,
 NULL
};

struct Gadget PrintHeightGadg =
{
 &PrintWidthGadg,
 176, 18,
 40, 9,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY | LONGINT,
 STRGADGET,
 NULL, NULL, NULL, NULL,
 (APTR) &PrintHeightInfo,
 2,
 NULL
};

struct Gadget LabelGapGadg =
{
 &PrintHeightGadg,
 176, 31,
 40, 9,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY | LONGINT,
 STRGADGET,
 NULL, NULL, NULL, NULL,
 (APTR) &LabelGapInfo,
 3,
 NULL
};

struct Gadget SetEditGadg =
{
 &LabelGapGadg,
 91, 43,
 137, 13,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 4,
 NULL
};

struct Gadget SetGadg =
{
 &SetEditGadg,
 8, 43,
 30, 13,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 5,
 NULL
};

struct Gadget OutGadg =
{
 &SetGadg,
 281, 43,
 31, 13,
 GADGHCOMP,
 GADGIMMEDIATE | RELVERIFY,
 BOOLGADGET,
 NULL, NULL, NULL, NULL, NULL,
 6,
 NULL
};

struct NewWindow SetUpWinData =
{
 160,82,
 320,60,
 1,1,
 GADGETUP,
 BORDERLESS | ACTIVATE | RMBTRAP | BACKDROP,
 &OutGadg,
 NULL, NULL,
 NULL,NULL,NULL,
 NULL,NULL,NULL,
 CUSTOMSCREEN,
};

BYTE InformationText[2][14][51] =
{
 {
  "                  Label Maker V1.5                ",
  "                                                  ",
  "  1991 by Stefan G. Boldorf, all rights reserved ",
  "                                                  ",
  "Consult the file 'LabelMakerV1.5.doc' for copying ",
  "restrictions and usage of the Label Maker.        ",
  "                                                  ",
  "This program may not be copied without the files  ",
  "'LabelMakerV1.5.doc' and 'LabelMakerV1.5.zoo'.    ",
  "All three files may not be changed in any way!!!  ",
  "                                                  ",
  "Thanx go to Thomas Geib and Bjrn-Eric Trost.     ",
  "                                                  ",
  "PD De/compactor routines by EA from FISH 185.     "
 },
 {
  "Very well, you have found the secret page!        ",
  "                                                  ",
  "As you may have discovered by now, I am a succer  ",
  "for those Japanese animated cartoon series like   ",
  "'ROBOTECH','NICKY LARSON' and 'THE LENSMAN'. Here ",
  "is something for those folks that feel obliged to ",
  "send me something or want a 'speedy update':      ",
  "If you happen to have drawn or digitised images   ",
  "of one of the above or other Japanese cartoon art ",
  "include them on the disk you send me (as long as  ",
  "they are PD, of course) and it will speed up the  ",
  "'updating process' or enlarge my gratitude a great",
  "deal!                                             ",
  "Like Captain Gloval said,  'FIRE THE MAIN GUN!'   ",
 }
};

